####################################################
# Researcher: Sara Schwarz
# Advisor: Dr. Jose Ortiz
# VERSION #1
# Program Objective:
#
#In this work we seek to develop algorithms (brute-force approach, TRW, etc) to detect network and port
#scanners on large-scale networks traffc such as those of Internet Service Providers,
#Big Data research centers, and Science DMZ networks implemented in research institutions using network
#flows. This specific program will follow a brute-force approach algorithm, of reading the network flows
#and recording for each source ip the destination ips and the different destination ports it connected to.
#Later, the number of connected ports will be compared with a threshold to classify the source ips as
#either suspicious scanners or not.
#To run this algorithm we will be using high-performance methods for computing such as Map and Reduce,
#specifically Python's Pool Class Library.
###############################################################


from silk import *
import multiprocessing as mp


#Para filtrar por puertos. Pero no queremos todavia
#minPort = 20
#maxPort = 5000


def verify_type(filename):

    dportHash = {} #contains amount of dport per each sip
    filename = [filename]
    #print "stooy aqui"

    for file in filename:

        for rec in silkfile_open(file, READ):#reading the flow file
            sip = str(rec.sip)
            dip = str(rec.dip)
            dport = rec.dport
            if (':' in sip): #Si en el paso anterior se vio que n                                                    #tiene el length de puertos requerido, se ignora

                # x+=1
                continue
            else:
                if sip in dportHash:
                    if dip in dportHash[sip]:
                        if dport in dportHash[sip][dip]:
                            dportHash[sip][dip][dport] += 1
                        else:
                            dportHash[sip][dip][dport] = 1
                    else:
                        dportHash[sip][dip] = {dport : 1}
                else:
                    dportHash[sip] = { dip: {dport: 1} }

    return dportHash

def join_hash(list):
    complete_hash ={}
    for i in list:
        for sip, hash in i.items():
            if sip in complete_hash:
                #print "hello", sip
                for dip, dports in i[sip].items():
                    #print dip
                    if dip in complete_hash[sip]:
                        #print "wassup"
                        for number, value in dports.items():
                            if number in complete_hash[sip]:
                                print "DPORTS", number
                                complete_hash[sip][dip][number] += value
                            else:
                                complete_hash[sip][dip][number]= value
                    else:
                        complete_hash[sip][dip]= dports
            else:
                complete_hash[sip]= hash
    return complete_hash


def main():
    #for accesing the network flows during a specific interval of time
    startDate = "2018/08/1"
    endDate = "2018/10/15"
    otherHash = {} #hash table for suspicious source ips with destination ips
    counter = 0
    threshold = 100
    #object for retrieving files from Silk data store. Specified the interval of time, the silk configuration file location, and the silk data location
    files = FGlob(classname="all", type="all", start_date=startDate, end_date=endDate, site_config_file="/etc/silk/conf-v9/silk.conf", data_rootdir="/home/scratch/flow/rwflowpack/")
#****************************************
# Using Pythons Pool Class for multiprocessing
#****************************************
    process_num = 2
    pool = mp.Pool(processes=process_num)
    #change files1 from FGlob object type to a list of silk data files
    files1 = [x for x in files]
    #Using map from Pool, returns a list of a hash per process, being the hash the output of verify_type
    fileHash = pool.map(verify_type, files1)
    #returns the hash of all hashes merged.
    flowHash = join_hash(fileHash)
    #print len(flowHash)
    #****************************************
#****************************************
#  Verifying the source ips
#****************************************
    #Will iterate through the hash of sips and dports
    #Verify whether the number of different dports per desitnation ip, connected to by the same source ip
    #is greater than our threshold. If it is, the source ip will be added to the hash suspicious sips.
    for sips in flowHash:
        for dips, dports in flowHash[sips].items():
            if len(dports) >= threshold:
                if sips in otherHash:
                    otherHash[sips][dips] = dports
                else:
                    otherHash[sips] = {dips: dports}

    for dips, dports in otherHash.items():
        counter +=1
    #prints the total number of suspicious source ips.
    print counter


if __name__== "__main__":
  main()
